#!/usr/bin/perl
# -----------------------------------------------------------------------------------------------------------------------------------
# File:        PleskMailCheck.pl
# For what:    Plesk modification with Dovecot and Postfix.
#              Sets the e-mail redirects (as virtual_aliases_dynamic) for usage with postfix
#              and mail groups & autoresponder (as dovecot sieves)
# Usage:       Set crontab on this script
# Author:      Kevin Lieser, kleaserarts - Mediendesign, info@ka-mediendesign.de, www.ka-mediendesign.de
# -----------------------------------------------------------------------------------------------------------------------------------

use DBI;
use utf8;

####
#### Datenbankverbindung & Vars
####

$dbh = DBI->connect('dbi:mysql:psa','admin','xxxxxxxxxxxxxxx');
my $mailFolder = "/var/qmail/mailnames/";  
 

####
#### E-Mail Weiterleitung
####
 
#
# DB auslesen und Inhalt erstellen
#
$sql    = "SELECT mail.id AS mail_id, mail.mail_name AS mail_group, domains.name AS mail_group_domain, mail.mail_group AS mail_group_active, mail.postbox AS mail_postbox, domains.id AS domain_id FROM domains,mail WHERE domains.id=mail.dom_id";
$sqlsth = $dbh->prepare($sql);
$sqlsth->execute;
while (@mysqldata = $sqlsth->fetchrow_array) {
	
	if($mysqldata[3] eq "true" && $mysqldata[4] eq "false") {
        my $sql2    = "SELECT GROUP_CONCAT(mail_redir.address) AS mail_group_forwards FROM mail_redir WHERE mail_redir.mn_id = ".$mysqldata[0];
        my $sqlsth2 = $dbh->prepare($sql2);
        $sqlsth2->execute;
        if($sqlsth2->rows != 0) {
			
			# Single Mail
			@mysqldataGroups = $sqlsth2->fetchrow_array;
			$bodyredir .= $mysqldata[1].'@'.$mysqldata[2].' '.$mysqldataGroups[0].'
';
			
			# Domain Aliases
			$sql4    = "SELECT domainaliases.name AS dom_name FROM domainaliases WHERE dom_id = ".$mysqldata[5];
			$sqlsth4 = $dbh->prepare($sql4);
			$sqlsth4->execute;
			while (@mysqldatadomalias = $sqlsth4->fetchrow_array) {
				$bodyredir .= $mysqldata[1].'@'.$mysqldatadomalias[0].' '.$mysqldataGroups[0].'
';
			}
			
			# Mail Aliases & Domain Aliases
			$sql3    = "SELECT mail_aliases.alias AS mail_alias FROM mail_aliases WHERE mn_id = ".$mysqldata[0];
			$sqlsth3 = $dbh->prepare($sql3);
			$sqlsth3->execute;
			while (@mysqldataalias = $sqlsth3->fetchrow_array) {
				
				# Single Alias
				$bodyredir .= $mysqldataalias[0].'@'.$mysqldata[2].' '.$mysqldataGroups[0].'
';

				# Domain Aliases
				$sql4    = "SELECT domainaliases.name AS dom_name FROM domainaliases WHERE dom_id = ".$mysqldata[5];
				$sqlsth4 = $dbh->prepare($sql4);
				$sqlsth4->execute;
				while (@mysqldatadomalias = $sqlsth4->fetchrow_array) {
					$bodyredir .= $mysqldataalias[0].'@'.$mysqldatadomalias[0].' '.$mysqldataGroups[0].'
';
				}
				
			}
		}
	}
    
}



#
# Datei lesen
#
local(*dynvirtualfile, $/);
open(dynvirtualfile, "</etc/postfix/virtual_aliases_dynamic");
my $dynvirtualfile = <dynvirtualfile>;
close(dynvirtualfile);

#
# Daten schreiben, wenn geaendert
#
if($dynvirtualfile ne $bodyredir) {
    #
    # Datei schreiben
    #
    open(dynvirtualfile, ">/etc/postfix/virtual_aliases_dynamic");
    print dynvirtualfile $bodyredir;
	close(dynvirtualfile);
	
	#
	# Postmap erstellen
	#
	system "/usr/sbin/postmap /etc/postfix/virtual_aliases_dynamic";
}

	


####
#### SpamCHK Table
####
 
#
# DB auslesen und Inhalt erstellen
#
$sql    = "SELECT CONCAT_WS(\"@\",mail.mail_name,domains.name) AS mail_redirect, mail.redir_addr AS mail_forward FROM domains,mail WHERE domains.id=mail.dom_id";
$sqlsth = $dbh->prepare($sql);
$sqlsth->execute;
while (@mysqldata = $sqlsth->fetchrow_array) {
    $body .= $mysqldata[0].' '.$mysqldata[1].'
';
}

#
# Datei lesen
#
local(*spamchkfile, $/);
open(spamchkfile, "</var/vmail/spamchk.table");
my $spamchkfile = <spamchkfile>;
close(spamchkfile);

#
# Daten schreiben, wenn geaendert
#
if($spamchkfile ne $body) {
    #
    # Datei schreiben
    #
    open(spamchkfile, ">/var/vmail/spamchk.table");
    print spamchkfile $body;
    close(spamchkfile);
}


####
#### E-Mail Gruppen
####       

#
# Gruppen finden
#
my $sql1    = "SELECT mail.id AS mail_id, mail.mail_name AS mail_group, domains.name AS mail_group_domain, mail.mail_group AS mail_group_active, mail.postbox AS mail_postbox FROM domains,mail WHERE domains.id=mail.dom_id";
my $sqlsth1 = $dbh->prepare($sql1);
$sqlsth1->execute;
while (@mysqldata = $sqlsth1->fetchrow_array) {
  
    #
    # Mailgruppe aktiv / Sieve checken / anlegen
    #
    if($mysqldata[3] eq "true" && $mysqldata[4] eq "true") {
        my $sql2    = "SELECT mail_redir.address AS mail_group_forwards FROM mail_redir WHERE mail_redir.mn_id = ".$mysqldata[0];
        my $sqlsth2 = $dbh->prepare($sql2);
        $sqlsth2->execute;
        if($sqlsth2->rows != 0) {
        
            #
            # Daten existieren -> Update
            #
            if(-f $mailFolder.$mysqldata[2]."/".$mysqldata[1]."/.dovecot.sieve") {
                local(*sievefile, $/);
                open(sievefile, "<".$mailFolder.$mysqldata[2]."/".$mysqldata[1]."/.dovecot.sieve");
                $sieveContent = <sievefile>;
                $sieveContentOrig = $sieveContent;
                close(sievefile);
                
                #
                # Bestehende Rule entfernen
                #
                $startpos = index($sieveContent, "# rule:[Plesk Mailgruppe]");
                if($startpos != -1) {
                    $endpos   = index($sieveContent, "}", $startpos) + 2;
                    $part1    = substr $sieveContent, 0, $startpos;
                    $part2    = substr $sieveContent, $endpos;
                    $sieveContent = $part1.$part2;
                }
                
                #
                # Neue Rule einfuegen
                #
                $startposFile = index($sieveContent, "\"];");
                $part1    = substr $sieveContent, 0, $startposFile + 3;
                $part2    = substr $sieveContent, $startposFile + 3;
                $newSieveFile = $part1."\n";
                
                $newSieveFile .= "# rule:[Plesk Mailgruppe]\n";
                $newSieveFile .= "if anyof (true)\n";
                $newSieveFile .= "{\n";
                $newSieveFile .= "	fileinto \"INBOX\";\n";
                while (@mysqldataGroups = $sqlsth2->fetchrow_array) {
                $newSieveFile .= "	redirect \"".$mysqldataGroups[0]."\";\n"; }
                $newSieveFile .= "}"; 
                
                $newSieveFile .= $part2;  
                
                #
                # Daten schreiben, wenn geaendert
                #
                if($newSieveFile ne $sieveContentOrig) {
                    open(sievefile, ">".$mailFolder.$mysqldata[2]."/".$mysqldata[1]."/.dovecot.sieve");
                    print sievefile $newSieveFile;
                    close(sievefile);
                }

            #
            # Daten existieren nicht -> Anlegen
            #  
            } else {
                system "mkdir ".$mailFolder.$mysqldata[2]."/".$mysqldata[1]."/sieve";
                system "chmod 700 ".$mailFolder.$mysqldata[2]."/".$mysqldata[1]."/sieve";
                system "mkdir ".$mailFolder.$mysqldata[2]."/".$mysqldata[1]."/sieve/tmp";
                system "chown -R popuser:popuser ".$mailFolder.$mysqldata[2]."/".$mysqldata[1]."/sieve";
                
                $newSieveFile  = "require [\"fileinto\"];\n";
                $newSieveFile .= "# rule:[Plesk Mailgruppe]\n";
                $newSieveFile .= "if anyof (true)\n";
                $newSieveFile .= "{\n";
                $newSieveFile .= "	fileinto \"INBOX\";\n";
                while (@mysqldataGroups = $sqlsth2->fetchrow_array) {
                $newSieveFile .= "	redirect \"".$mysqldataGroups[0]."\";\n"; }
                $newSieveFile .= "}"; 

                open(sievefile, ">".$mailFolder.$mysqldata[2]."/".$mysqldata[1]."/sieve/roundcube.sieve");
                print sievefile $newSieveFile;
                close(sievefile);
                system "ln -s ".$mailFolder.$mysqldata[2]."/".$mysqldata[1]."/sieve/roundcube.sieve ".$mailFolder.$mysqldata[2]."/".$mysqldata[1]."/.dovecot.sieve";
            } 
        }
    }
    
    #
    # Sieve Rules entfernen
    #
    else {
        if(-f $mailFolder.$mysqldata[2]."/".$mysqldata[1]."/.dovecot.sieve") {
            local(*sievefile, $/);
            open(sievefile, "<".$mailFolder.$mysqldata[2]."/".$mysqldata[1]."/.dovecot.sieve");
            my $sieveContent = <sievefile>;
            close(sievefile);
            $startpos = index($sieveContent, "# rule:[Plesk Mailgruppe]");
            if($startpos != -1) {
                $endpos   = index($sieveContent, "}", $startpos) + 2;
                $part1    = substr $sieveContent, 0, $startpos;
                $part2    = substr $sieveContent, $endpos;
                $endSieveFile = $part1.$part2;
                open(sievefile, ">".$mailFolder.$mysqldata[2]."/".$mysqldata[1]."/.dovecot.sieve");
                print sievefile $endSieveFile;
                close(sievefile);
            }
        }
    }
}


####
#### E-Mail Autoresponder
####        

#
# Autoresponder finden
#
my $sql3    = "SELECT mail.id AS mail_id, mail.mail_name AS mail_name_before, domains.name AS mail_name_after, mail.autoresponder AS autoresponder FROM domains,mail WHERE domains.id=mail.dom_id";
my $sqlsth3 = $dbh->prepare($sql3);
$sqlsth3->execute;
while (@mysqlautoresp = $sqlsth3->fetchrow_array) {
    
    #
    # Autoresponder aktiv / Sieve checken / anlegen
    #
    if($mysqlautoresp[3] eq "true") {
        my $sql4    = "SELECT id AS mail_id, resp_name AS responder_name, ans_freq AS responder_freq, content_type AS responder_type, text AS responder_text, subject AS responder_subject, key_where AS filter_type, keystr AS filter_text, charset AS responder_charset FROM mail_resp WHERE resp_on = \"true\" AND mn_id = ".$mysqlautoresp[0];
        my $sqlsth4 = $dbh->prepare($sql4);
        $sqlsth4->execute;
        $tempSieveFile = "";
        while (@mysqlautorespData = $sqlsth4->fetchrow_array) {
            # $mysqlautorespData[0]             -> ID
            # $mysqlautorespData[1]             -> Name
            # $mysqlautorespData[2]             -> Freq
            # $mysqlautorespData[3]             -> Type
            # $mysqlautorespData[4]             -> Text
            # $mysqlautorespData[5]             -> Subject
            # $mysqlautorespData[6]             -> Keywhere
            # $mysqlautorespData[7]             -> Keystr
            # $mysqlautorespData[8]             -> Charset

            #
            # Forward Address
            #
            my $sql5    = "SELECT resp_forward.address AS forward_address FROM mail_resp,resp_forward WHERE resp_forward.rn_id = ".$mysqlautorespData[0]." LIMIT 1";
            my $sqlsth5 = $dbh->prepare($sql5);
            $sqlsth5->execute;
            if($sqlsth5->rows != 0) {
                @mysqlautorespDataForward = $sqlsth5->fetchrow_array;
                $responderForward = "	redirect \"".$mysqlautorespDataForward[0]."\";\n";
            } else {
                $responderForward = "";
            }
            
            $mysqlautorespData[5] =~ s/\<request_subject\>/\$\{subject\}/gc;
            
            $tempSieveFile .= "\n# rule:[Plesk Autoresponder ".$mysqlautorespData[1]."]\n";
            $tempSieveFile .= "set \"subject\" \"\";\n";
            $tempSieveFile .= "if header :matches \"subject\" \"*\" { set \"subject\" \"\$\{1\}\"; }\n";
            
            if($mysqlautorespData[6] eq "no") {   $tempSieveFile .= "if anyof (true)\n"; }
            if($mysqlautorespData[6] eq "subj") { $tempSieveFile .= "if allof (header :contains \"Subject\" \"".$mysqlautorespData[7]."\")\n"; }
            if($mysqlautorespData[6] eq "body") { $tempSieveFile .= "if body :text :contains \"".$mysqlautorespData[7]."\"\n"; }
            
            $tempSieveFile .= "{\n";
            #$tempSieveFile .= "	fileinto \"INBOX\";\n";
            $tempSieveFile .= $responderForward;
            
            #
            # HTML Format
            #
            if($mysqlautorespData[3] eq "text/html") {
            
                $mysqlautorespData[4] =~ s/\"/\\\"/gc;
                $tempSieveFile .= '	vacation :days 1 :subject "'.$mysqlautorespData[5].'" :mime "Content-Type: text/html; charset='.$mysqlautorespData[8].'
Content-Transfer-Encoding: 7bit
<!DOCTYPE html PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">
<HTML><HEAD><META http-equiv=Content-Type content=\"text/html; charset='.$mysqlautorespData[8].'\">
</HEAD><BODY> '.$mysqlautorespData[4].'</BODY></HTML>";'."\n";

            #
            # Plain Text
            #
            } else {
                $tempSieveFile .= "	vacation :days 1 :subject \"".$mysqlautorespData[5]."\" :mime \"MIME-Version: 1.0
Content-Type: text/plain; charset=".$mysqlautorespData[8]." ".$mysqlautorespData[4]."\";\n";
            }

            $tempSieveFile .= "}"; 
        }
    
        #
        # Daten existieren -> Update
        #
        if(-f $mailFolder.$mysqlautoresp[2]."/".$mysqlautoresp[1]."/.dovecot.sieve") {
            local(*sievefile, $/);
            open(sievefile, "<".$mailFolder.$mysqlautoresp[2]."/".$mysqlautoresp[1]."/.dovecot.sieve");
            $sieveContent = <sievefile>;
            $sieveContentOrig = $sieveContent;
            close(sievefile);
            
            #
            # Bestehende Rules entfernen
            #
            while(index($sieveContent, "# rule:[Plesk Autoresponder") != -1) {
                $startpos = index($sieveContent, "# rule:[Plesk Autoresponder");
                if($startpos != -1) {
                    $endpos   = index($sieveContent, "\n}", $startpos) + 3;
                    $part1    = substr $sieveContent, 0, $startpos;
                    $part2    = substr $sieveContent, $endpos;
                    $sieveContent = $part1.$part2;
                }
            }
            
            $startposFile = index($sieveContent, "\"];");
            $part1    = substr $sieveContent, 0, $startposFile + 3;
            $part2    = substr $sieveContent, $startposFile + 3;
            $newSieveFile = $part1.$tempSieveFile.$part2;
            
            if(index($newSieveFile, "\"vacation\"") == -1) {   $newSieveFile =~ s/\"fileinto\"/\"fileinto\"\,\"vacation\"/gc; }
            if(index($newSieveFile, "\"variables\"") == -1) {  $newSieveFile =~ s/\"vacation\"/\"vacation\",\"variables\"/gc; }
            if(index($newSieveFile, "\"body\"") == -1) {       $newSieveFile =~ s/\"vacation\"/\"vacation\",\"body\"/gc; }
            
            #
            # Neue Daten schreiben, wenn geaendert
            #
            if($newSieveFile ne $sieveContentOrig) {
                open(sievefile, ">".$mailFolder.$mysqlautoresp[2]."/".$mysqlautoresp[1]."/.dovecot.sieve");
                print sievefile $newSieveFile;
                close(sievefile);
            }
  
        #
        # Daten existieren nicht -> Anlegen
        #  
        } else {
            system "mkdir ".$mailFolder.$mysqlautoresp[2]."/".$mysqlautoresp[1]."/sieve";
            system "chmod 700 ".$mailFolder.$mysqlautoresp[2]."/".$mysqlautoresp[1]."/sieve";
            system "mkdir ".$mailFolder.$mysqlautoresp[2]."/".$mysqlautoresp[1]."/sieve/tmp";
            system "chown -R popuser:popuser ".$mailFolder.$mysqlautoresp[2]."/".$mysqlautoresp[1]."/sieve";

            $newSieveFile  = "require [\"fileinto\",\"vacation\",\"variables\"];";
            $newSieveFile .= $tempSieveFile; 

            open(sievefile, ">".$mailFolder.$mysqlautoresp[2]."/".$mysqlautoresp[1]."/sieve/roundcube.sieve");
            print sievefile $newSieveFile;
            close(sievefile);
            system "ln -s ".$mailFolder.$mysqlautoresp[2]."/".$mysqlautoresp[1]."/sieve/roundcube.sieve ".$mailFolder.$mysqlautoresp[2]."/".$mysqlautoresp[1]."/.dovecot.sieve";
        }      
    }   

    #
    # Autoresponder entfernen
    #
    else {
        if(-f $mailFolder.$mysqlautoresp[2]."/".$mysqlautoresp[1]."/.dovecot.sieve") {
            local(*sievefile, $/);
            open(sievefile, "<".$mailFolder.$mysqlautoresp[2]."/".$mysqlautoresp[1]."/.dovecot.sieve");
            $sieveContent = <sievefile>;
            $sieveContentOrig = $sieveContent;
            close(sievefile);
            while(index($sieveContent, "# rule:[Plesk Autoresponder") != -1) {
                $startpos = index($sieveContent, "# rule:[Plesk Autoresponder");
                if($startpos != -1) {
                    $endpos   = index($sieveContent, "\n}", $startpos) + 3;
                    $part1    = substr $sieveContent, 0, $startpos;
                    $part2    = substr $sieveContent, $endpos;
                    $sieveContent = $part1.$part2;
                }
            }
            
            #
            # Daten schreiben, wenn geaendert
            #
            if($sieveContentOrig ne $sieveContent) {
                open(sievefile, ">".$mailFolder.$mysqlautoresp[2]."/".$mysqlautoresp[1]."/.dovecot.sieve");
                print sievefile $sieveContent;
                close(sievefile);
            }
        }
    }
}